/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.ruoyi.common.core.domain.R
 *  com.ruoyi.common.core.utils.StringUtils
 *  com.ruoyi.common.core.utils.file.FileTypeUtils
 *  com.ruoyi.common.core.utils.file.MimeTypeUtils
 *  com.ruoyi.common.core.web.controller.BaseController
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.common.log.annotation.Log
 *  com.ruoyi.common.log.enums.BusinessType
 *  com.ruoyi.common.security.service.TokenService
 *  com.ruoyi.common.security.utils.SecurityUtils
 *  com.ruoyi.system.api.RemoteFileService
 *  com.ruoyi.system.api.domain.SysFile
 *  com.ruoyi.system.api.domain.SysUser
 *  com.ruoyi.system.api.model.LoginUser
 *  com.ruoyi.system.controller.SysProfileController
 *  com.ruoyi.system.enums.BussLogEnum
 *  com.ruoyi.system.service.ISnServerService
 *  com.ruoyi.system.service.ISysBussLogService
 *  com.ruoyi.system.service.ISysUserService
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RequestParam
 *  org.springframework.web.bind.annotation.RestController
 *  org.springframework.web.multipart.MultipartFile
 */
package com.ruoyi.system.controller;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.utils.file.FileTypeUtils;
import com.ruoyi.common.core.utils.file.MimeTypeUtils;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.service.TokenService;
import com.ruoyi.common.security.utils.SecurityUtils;
import com.ruoyi.system.api.RemoteFileService;
import com.ruoyi.system.api.domain.SysFile;
import com.ruoyi.system.api.domain.SysUser;
import com.ruoyi.system.api.model.LoginUser;
import com.ruoyi.system.enums.BussLogEnum;
import com.ruoyi.system.service.ISnServerService;
import com.ruoyi.system.service.ISysBussLogService;
import com.ruoyi.system.service.ISysUserService;
import java.util.Arrays;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

@RestController
@RequestMapping(value={"/user/profile"})
public class SysProfileController
extends BaseController {
    @Autowired
    private ISysUserService userService;
    @Autowired
    private TokenService tokenService;
    @Autowired
    private RemoteFileService remoteFileService;
    @Autowired
    private ISysBussLogService sysBussLogService;
    @Autowired
    private ISnServerService snServerService;

    @GetMapping
    public AjaxResult profile() {
        String username = SecurityUtils.getUsername();
        SysUser user = this.userService.selectUserByUserName(username);
        AjaxResult ajax = AjaxResult.success((Object)user);
        ajax.put("roleGroup", (Object)this.userService.selectUserRoleGroup(username));
        ajax.put("postGroup", (Object)this.userService.selectUserPostGroup(username));
        return ajax;
    }

    @Log(title="个人信息", businessType=BusinessType.UPDATE)
    @PutMapping
    public AjaxResult updateProfile(@RequestBody SysUser user) {
        LoginUser loginUser = SecurityUtils.getLoginUser();
        SysUser currentUser = loginUser.getSysUser();
        currentUser.setNickName(user.getNickName());
        currentUser.setEmail(user.getEmail());
        currentUser.setPhonenumber(user.getPhonenumber());
        currentUser.setSex(user.getSex());
        if (StringUtils.isNotEmpty((String)user.getPhonenumber()) && !this.userService.checkPhoneUnique(currentUser)) {
            return this.error("修改用户'" + loginUser.getUsername() + "'失败，手机号码已存在");
        }
        if (StringUtils.isNotEmpty((String)user.getEmail()) && !this.userService.checkEmailUnique(currentUser)) {
            return this.error("修改用户'" + loginUser.getUsername() + "'失败，邮箱账号已存在");
        }
        if (this.userService.updateUserProfile(currentUser) > 0) {
            this.tokenService.setLoginUser(loginUser);
            return this.success();
        }
        return this.error("修改个人信息异常，请联系管理员");
    }

    @Log(title="个人信息", businessType=BusinessType.UPDATE)
    @PutMapping(value={"/updatePwd"})
    public AjaxResult updatePwd(String oldPassword, String newPassword) {
        String username = SecurityUtils.getUsername();
        SysUser user = this.userService.selectUserByUserName(username);
        String password = user.getPassword();
        if (!SecurityUtils.matchesPassword((String)oldPassword, (String)password)) {
            return this.error("修改密码失败，旧密码错误");
        }
        if (SecurityUtils.matchesPassword((String)newPassword, (String)password)) {
            return this.error("新密码不能与旧密码相同");
        }
        this.sysBussLogService.insertSysBussLog(BussLogEnum.EditPassword.getType(), user.getUserId(), user.getUserName(), "修改密码 " + oldPassword + " => " + newPassword);
        newPassword = SecurityUtils.encryptPassword((String)newPassword);
        if (this.userService.resetUserPwd(username, newPassword) > 0) {
            if (user.getUserType().equals("common")) {
                this.snServerService.logoutMerchant(user.getUserId());
            }
            LoginUser loginUser = SecurityUtils.getLoginUser();
            loginUser.getSysUser().setPassword(newPassword);
            this.tokenService.setLoginUser(loginUser);
            return this.success();
        }
        return this.error("修改密码异常，请联系管理员");
    }

    @Log(title="用户头像", businessType=BusinessType.UPDATE)
    @PostMapping(value={"/avatar"})
    public AjaxResult avatar(@RequestParam(value="avatarfile") MultipartFile file) {
        if (!file.isEmpty()) {
            LoginUser loginUser = SecurityUtils.getLoginUser();
            String extension = FileTypeUtils.getExtension((MultipartFile)file);
            if (!StringUtils.equalsAnyIgnoreCase((CharSequence)extension, (CharSequence[])MimeTypeUtils.IMAGE_EXTENSION)) {
                return this.error("文件格式不正确，请上传" + Arrays.toString(MimeTypeUtils.IMAGE_EXTENSION) + "格式");
            }
            R fileResult = this.remoteFileService.upload(file);
            if (StringUtils.isNull((Object)fileResult) || StringUtils.isNull((Object)fileResult.getData())) {
                return this.error("文件服务异常，请联系管理员");
            }
            String url = ((SysFile)fileResult.getData()).getUrl();
            if (this.userService.updateUserAvatar(loginUser.getUsername(), url)) {
                AjaxResult ajax = AjaxResult.success();
                ajax.put("imgUrl", (Object)url);
                loginUser.getSysUser().setAvatar(url);
                this.tokenService.setLoginUser(loginUser);
                return ajax;
            }
        }
        return this.error("上传图片异常，请联系管理员");
    }
}

